/**
 * Copyright (c) 2016 Razeware LLC
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

import Foundation

struct Video {

  let previewImageName: String
  let title: String
  let videoName: String

  var videoURL: URL!
}

// MARK: - Static Constructors
extension Video {

  static func videosFrom(array: [[String: String]]) -> [Video] {
    return array.map { Video.videoFrom(dictionary: $0) }
  }

  static func videoFrom(dictionary: [String: String]) -> Video {
    let previewImageName = dictionary["previewImageName"]!
    let title = dictionary["videoTitle"]!
    let videoName = dictionary["videoName"]!
    return Video(previewImageName: previewImageName, title: title, videoName: videoName, videoURL: nil)
  }

}
