/**
 * Copyright (c) 2016 Razeware LLC
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

import Foundation
import CloudKit

let GlobalModel = Model()

let MyMovieNotification = Notification.Name("movies.mymovies")
let MyQueueNotification = Notification.Name("movies.myqueue")

class Model {
  var container: CKContainer { return CKContainer.default() }
  var publicDatabase: CKDatabase { return container.publicCloudDatabase }
  var privateDatabase: CKDatabase { return container.privateCloudDatabase }

  private func fetchUserId(_ completion: @escaping (CKRecordID) -> Void) {
    let error = NSError(domain: "MoviesMoviesMovies", code: 0, userInfo: [NSLocalizedDescriptionKey : "This method has not been implemented yet"])
    showError(error, inController: nil)
  }

  func withUserRecord(_ completion: @escaping (CKRecord) -> Void) {
    fetchUserId { userId in
      self.fetchUserRecord(userId, completion: completion)
    }
  }

  private func fetchUserRecord(_ userId: CKRecordID, completion: (CKRecord) -> Void) {
    let error = NSError(domain: "MoviesMoviesMovies", code: 0, userInfo: [NSLocalizedDescriptionKey : "This method has not been implemented yet"])
    showError(error, inController: nil)
  }

}

// MARK: - Adding and Finding a Movie
extension Model {
  func createNewMovie(_ movie: Movie, handler: (CKRecord) -> Void) {
    let error = NSError(domain: "MoviesMoviesMovies", code: 0, userInfo: [NSLocalizedDescriptionKey : "This method has not been implemented yet"])
    showError(error, inController: nil)
  }

  func movieForTitle(_ title: String, completion: (_ record: CKRecord?, _ error: NSError?) -> ()) {
    let error = NSError(domain: "MoviesMoviesMovies", code: 0, userInfo: [NSLocalizedDescriptionKey : "This method has not been implemented yet"])
    showError(error, inController: nil)
  }

  func withMovieRecord(_ movie: Movie, completion: (CKRecord) -> Void) {
    let error = NSError(domain: "MoviesMoviesMovies", code: 0, userInfo: [NSLocalizedDescriptionKey : "This method has not been implemented yet"])
    showError(error, inController: nil)
  }
}

// MARK: - My Movies
extension Model {

  func fetchMovies(_ completion: (_ movies: [CKRecord]?, _ error: NSError?) -> ()) {
    // fill out with code fetch the my movies list
  }

  func addToMyMovies(_ movie: Movie) {
    createNewMovie(movie) { _ in }
  }

  func removeFromMyMovies(_ movie: Movie) {
    let error = NSError(domain: "MoviesMoviesMovies", code: 0, userInfo: [NSLocalizedDescriptionKey : "This method has not been implemented yet"])
    showError(error, inController: nil)
  }

}

// MARK: - My Queue
extension Model {
  func fetchQueue(_ completion: (_ movies: [CKRecord]?, _ error: NSError?) -> ()) {
    // fill out with code fetch the my queue list
  }

  func addToMyQueue(_ movie: Movie) {
    let error = NSError(domain: "MoviesMoviesMovies", code: 0, userInfo: [NSLocalizedDescriptionKey : "This method has not been implemented yet"])
    showError(error, inController: nil)
  }

  private func addRecordToMyQueue(_ movieRecord: CKRecord) {
    let error = NSError(domain: "MoviesMoviesMovies", code: 0, userInfo: [NSLocalizedDescriptionKey : "This method has not been implemented yet"])
    showError(error, inController: nil)
  }

  func updateQueue(_ newQueue: [CKRecord]) {
    let error = NSError(domain: "MoviesMoviesMovies", code: 0, userInfo: [NSLocalizedDescriptionKey : "This method has not been implemented yet"])
    showError(error, inController: nil)
  }
}

// MARK: - Recommendations
extension Model {

  func getTopTen(_ completion: ([CKRecord], NSError?) -> Void) {
  }

}

// MARK: - Rating
extension Model {

  func setRating(_ movie: Movie, rating: Int) {
    // Ratings are in the value of 1 to 5 stars. If the rating is zero, then it ratins is unset and it should be deleted
    let error = NSError(domain: "MoviesMoviesMovies", code: 0, userInfo: [NSLocalizedDescriptionKey : "This method has not been implemented yet"])
    showError(error, inController: nil)
  }

}
