/**
 * Copyright (c) 2016 Razeware LLC
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */


import Foundation
import UIKit

func jumpToMyMovies() {
  let tabs = UIApplication.shared.windows[0].rootViewController as! UITabBarController
  if tabs.selectedViewController?.presentedViewController != nil {
    // dismiss the modal heirarchy
    tabs.selectedViewController!.dismiss(animated: true) { jumpToMyMovies() }
  }  else {
    tabs.selectedIndex = 0
  }
}

enum MovieActions {
  case addToQueue, addToMovies, rate, remove
}

extension Movie {
  func movieActionController(presentingController controller: UIViewController, actionsToLeaveOut: MovieActions? = nil) -> UIViewController {
    let movieController = UIStoryboard(name: "MovieView", bundle: nil).instantiateInitialViewController() as! MovieViewController
    movieController.movie = self
    return movieController
  }
}
