/**
 * Copyright (c) 2016 Razeware LLC
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

import UIKit

class MovieSectionHeader: UILabel {

  required init?(coder aDecoder: NSCoder) {
    super.init(coder: aDecoder)
    textColor = UIColor.highlightColor
  }

  override func draw(_ rect: CGRect) {
    // draw a gradient

    let leftColor = UIColor.backgroundColor.cgColor
    let rightColor = UIColor.backgroundColor.withAlphaComponent(0.0).cgColor
    let colors: CFArray = [leftColor, rightColor] as CFArray
    let gradient = CGGradient(colorsSpace: CGColorSpaceCreateDeviceRGB(), colors: colors, locations: [0, 1])!
    UIGraphicsGetCurrentContext()?.drawLinearGradient(gradient, start: CGPoint(x: 0,y: rect.midY), end: CGPoint(x: rect.maxX, y: rect.midY), options: CGGradientDrawingOptions(rawValue: 0))
    super.draw(rect)
  }

  override func drawText(in rect: CGRect) {
    let insets = UIEdgeInsets(top: 0, left: 20, bottom: 0, right: 20)
    super.drawText(in: UIEdgeInsetsInsetRect(rect, insets))
  }
}
