/*
 * Copyright (c) 2016 Razeware LLC
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

import UIKit
import Photos

class SlideshowsViewController: UICollectionViewController {
  
  @IBOutlet weak var emptySlideshowView: UIView!
  
  // MARK: - Variables
  fileprivate let reuseIdentifier = "SlideshowCell"
  
  // Segues
  enum Segues: String {
    case SegueSlideshowsToAssetPicker
    case SegueSlideshowsToSlideshowDetail
  }
  
  fileprivate var slideshows: [Slideshow] = [] {
    didSet {
      emptySlideshowView.isHidden = slideshows.count > 0
    }
  }
  
  override func viewDidLoad() {
    super.viewDidLoad()
    
    self.navigationItem.leftBarButtonItem = nil
    self.splitViewController?.preferredDisplayMode = .primaryHidden
  }
  
  override func viewWillAppear(_ animated: Bool) {
    super.viewWillAppear(animated)
    
    // TBD: Configure caching and load slideshows
  }
  
  // MARK: - Navigation
  override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
    if segue.identifier == Segues.SegueSlideshowsToSlideshowDetail.rawValue {
      let destination = segue.destination as! SlideshowPageViewController
      let indexPath = collectionView!.indexPath(for: sender as! GridViewCell)!
      let slideshow = slideshows[indexPath.item] 
      destination.slideshow = slideshow
    } else if segue.identifier == Segues.SegueSlideshowsToAssetPicker.rawValue {
      let destination = (segue.destination as! UINavigationController).childViewControllers.first as! AssetGridViewController
      destination.selectedAssets = SelectedAssets()
    }
  }
  
  // MARK: - Private helper methods
  private func loadSlideshows() {
    // TBD: Load slideshows
  }
  
}

// MARK: - UICollectionViewDelegate, UICollectionViewDataSource
extension SlideshowsViewController {
  override func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
    return slideshows.count
  }
  
  override func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
    let cell = collectionView.dequeueReusableCell(withReuseIdentifier: reuseIdentifier, for: indexPath) as! GridViewCell
    
    // TBD: Configure the cell
    
    return cell
  }
  
}
