// AVAILABLE HERE: http://bit.ly/1OTc647


/****************************************************
 * EVENTS AND `THIS` [COMPLETE]
 ****************************************************/

const emitter = new EventEmitter();
const EVENT_ID = "boom";

/* EVENT LISTENERS */
console.log("/* EVENT LISTENERS */");

emitter.addListener(EVENT_ID, function(event) {
  console.log("== INLINE FUNCTION ==");
  console.log(this);
  console.log(event);
});

emitter.addListener(EVENT_ID, event => {
  console.log("== INLINE => FUNCTION ==");
  console.log(this);
  console.log(event);
});



class EventHandler {
  handleEvents(emitter) {
    emitter.addListener(EVENT_ID, this._handleEvent);
    emitter.addListener(EVENT_ID,
      this._handleEventBound.bind(this));
  }
  
  _handleEvent(event) {
    console.log("=== CLASS METHOD ===");
    console.log(this);
    console.log(event);
  }
  
  _handleEventBound(event) {
    console.log("=== BOUND CLASS METHOD ===");
    console.log(this);
    console.log(event);
    this._hello();
  }
  
  _hello() {
    console.log("== HELLO FROM EVENT HANDLER ==");
  }
}


const handler = new EventHandler();
handler.handleEvents(emitter);




// Leave me at the bottom!
emitter.emitEvent(EVENT_ID, [{event: "Sample event"}]);
