// AVAILABLE HERE: http://bit.ly/1PRGPDR

/***********************************************************
 * FUNCTIONS & CLASSES in JavaScript [COMPLETE]
 ***********************************************************/

/* Functions */
console.log("/* Functions */");

function square(num) {
  return num * num;
}

console.log(square(4));


function squareWithCallback(num, callback) {
  callback(num * num);
}

const retVal = squareWithCallback(5, function(result) {
  console.log(`Result: ${result}`);
});

console.log(`Return Value = ${retVal}`);

squareWithCallback(6, console.log);



/* => Functions */

squareWithCallback(7, res => console.log(`=> Result: ${res}`));

const printResult = (res) => console.log(`=> Result: ${res}`);
squareWithCallback(8, printResult);




/* Classes */
console.log("/* Classes */");

class Animal {
  constructor(name) {
    this._name = name;
  }
  
  describe() {
    console.log(`My name is ${this._name}`);
  }
}

const tony = new Animal("tony");
tony.describe();


class Dog extends Animal {
  describe() {
    console.log("I am a dog");
    super.describe();
  }
}

const spot = new Dog("spot");
spot.describe();




